/***********************************************************************
**                                                                    **
**  listing_10_6.c                                                    **
**                                                                    **
**  Scrollbar Demo. This program simply displays a scrollbar, and     **
**  catches all of that scrollbar's callbacks.                        **
**                                                                    **
***********************************************************************/


#include <Xm/ScrollBar.h>


void	ScrollCB();			/* FORWARD Definition	      */


Widget	appshell,			/* Application Shell	      */
	scroller;			/* The scrollbar              */


void main( argc, argv )
    int     argc;
    char    *argv[];
{
    appshell = XtInitialize( argv[0], "Listing_10_6", NULL, 0, &argc, argv );

    scroller = XmCreateScrollBar( appshell, "Scroller", NULL, 0 );
    XtManageChild( scroller );

    XtAddCallback( scroller, XmNdecrementCallback,     ScrollCB, NULL );
    XtAddCallback( scroller, XmNdragCallback,          ScrollCB, NULL );
    XtAddCallback( scroller, XmNincrementCallback,     ScrollCB, NULL );
    XtAddCallback( scroller, XmNpageDecrementCallback, ScrollCB, NULL );
    XtAddCallback( scroller, XmNpageIncrementCallback, ScrollCB, NULL );
    XtAddCallback( scroller, XmNtoBottomCallback,      ScrollCB, NULL );
    XtAddCallback( scroller, XmNtoTopCallback,         ScrollCB, NULL );
    XtAddCallback( scroller, XmNvalueChangedCallback,  ScrollCB, NULL );

    XtRealizeWidget( appshell );
    XtMainLoop();
}


void ScrollCB( w, client_data, call_data )
    Widget      		w;
    caddr_t			client_data;
    XmScrollBarCallbackStruct	*call_data;
{
    printf( "\nCallback...\n" );
    switch (call_data->reason)
        {
	case XmCR_DECREMENT :
		printf( "   Reason: Decrement\n" );
		break;
	case XmCR_DRAG :
		printf( "   Reason: Drag\n" );
		break;
	case XmCR_INCREMENT :
		printf( "   Reason: Increment\n" );
		break;
	case XmCR_PAGE_DECREMENT :
		printf( "   Reason: Page Decrement\n" );
		break;
	case XmCR_PAGE_INCREMENT :
		printf( "   Reason: Page Increment\n" );
		break;
	case XmCR_TO_BOTTOM :
		printf( "   Reason: To Bottom\n" );
		break;
	case XmCR_TO_TOP :
		printf( "   Reason: To Top\n" );
		break;
	case XmCR_VALUE_CHANGED :
		printf( "   Reason: Value Changed\n" );
		break;
        }
    printf( "   New Value: %d\n", call_data->value );
}
